---
title: PerformanceObserver
slug: Web/API/PerformanceObserver
tags:
  - API
  - Interface
  - Performance Observer API
  - PerformanceObserver
  - Reference
  - Web Performance
  - observers
---
<div>{{APIRef("Performance Timeline API")}}</div>

<p><span class="seoSummary">The <strong><code>PerformanceObserver</code></strong> interface is used to <em>observe</em> performance measurement events and be notified of new {{domxref("PerformanceEntry","performance entries", '', 'true')}} as they are recorded in the browser's <em>performance timeline</em>.</span></p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("PerformanceObserver.PerformanceObserver","PerformanceObserver()")}}</dt>
 <dd>Creates and returns a new <code>PerformanceObserver</code> object.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("PerformanceObserver.observe","PerformanceObserver.observe()")}}</dt>
 <dd>Specifies the set of {{domxref("PerformanceEntry.entryType","entry types")}} to observe. The performance observer's callback function will be invoked when a {{domxref("PerformanceEntry","performance entry")}} is recorded for one of the specified <code>entryTypes</code></dd>
 <dt>{{domxref("PerformanceObserver.disconnect","PerformanceObserver.disconnect()")}}</dt>
 <dd>Stops the performance observer callback from receiving {{domxref("PerformanceEntry","performance entries")}}.</dd>
 <dt>{{domxref("PerformanceObserver.takeRecords","PerformanceObserver.takeRecords()")}}</dt>
 <dd>Returns the current list of {{domxref("PerformanceEntry","performance entries")}} stored in the performance observer, emptying it out.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js">function perf_observer(list, observer) {
   // Process the "measure" event
}
var observer2 = new PerformanceObserver(perf_observer);
observer2.observe({entryTypes: ["measure"]});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Performance Timeline Level 2', '#dom-performanceobserver', 'PerformanceObserver')}}</td>
   <td>{{Spec2('Performance Timeline Level 2')}}</td>
   <td>Initial definition of <code>PerformanceObserver</code> interface.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.PerformanceObserver")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref('MutationObserver')}}</li>
 <li>{{domxref('ResizeObserver')}}</li>
 <li>{{domxref('IntersectionObserver')}}</li>
</ul>
